<template>
    <div  class="odds-queue active">
        <div class="queue-head" v-if="betsLoaded && opening">
            <div class="title">Opening odds at:</div>
            <div class="when">
                <div class="datetime">{{ formatDatestring(opening.last_update) }}</div>
                <div class="num">{{ opening.start_price }}</div>
            </div>
        </div>
        <div class="queue-items" v-if="betsLoaded && bets.length">
            <div class="queue-item" v-for="(bet, idx) in bets.reverse()" :key="idx" v-if="diffNum(bet.price, idx)!== 'NULL'" >
                <div class="datetime">{{ formatDatestring(bet.last_update) }}</div>
                <div class="num">{{ bet.price }}</div>
                <div
                    :class="[
                        'diff',
                        `diff-${diff(bet.price, idx)}`
                    ]"
                >{{ diffNum(bet.price, idx) }}</div>
            </div>
        </div>

    </div>
</template>

<script>
    import moment from 'moment'
    import {mapGetters, mapActions, mapMutations} from 'vuex'
    import HorizontalLoader from '../../HorizontalLoader'
    export default {
        name: 'MatchTableRowHistory',
        components: {HorizontalLoader},
        props: {
            bets: Array,
            current: Object,
            opening: Object,
            info: Object,
            betsLoaded: Boolean
        },
        computed: {

            ...mapGetters(['headerClockTime', 'headerClockTimezoneOffset', 'headerClockDate']),
    },
        methods: {
            hideBetsHistory() {
                this.$emit('hide-bets-history')
            },
            diff(currentPrice, index) {
                if (index === 0) return 'empty'
                if ( parseFloat(currentPrice) < parseFloat(this.bets[index-1].price) ) {
                    return 'red'
                } else if(parseFloat(currentPrice) === parseFloat(this.bets[index-1].price)) {
                    return 'empty'
                } else {
                    return 'green'
                }
            },
            diffNum(currentPrice, index) {
                if (index === 0) return 'NULL'
                let sign = parseFloat(currentPrice) < parseFloat(this.bets[index-1].price) ? '-' : '+'
                let result = (parseFloat(this.bets[index-1].price) - parseFloat(currentPrice))

                if (result === 0) return 'NULL'

                result = result < 0 ? -result : result

                return `${sign}${result.toFixed(2)}`
            },
            formatDatestring(ds) {
                return moment(ds, 'YYYY-MM-DDTHH:mm:ss').add(this.$store.getters.headerClockTimezoneOffset, 'h').format('DD MMM, HH:MM')
            }
        },

    }
</script>

<style scoped>

</style>
